require "email-opened/version"

class EmailOpened
  def initialize(api_key, version = 1, sandbox = false)
    @eo_api_key = api_key
    @eo_version = version
    @eo_sandbox = sandbox
  end
  
  def headers
    {
      "Authorization" => "Token token=\"#{@eo_api_key}\"",
      "Content-Type" => "application/json",
      "Accept" => "application/vnd.email-opened.v#{@eo_version}"
    }
  end

  def send(message = {})
    to = message[:to]
    token = message[:message_token]

    response = RestClient.post api_path + "messages", { "to[]" => to, token: token }, headers
    puts response
  end
  
  def messages
    response = RestClient.get api_path + "messages", headers
    puts response
  end
  
  def add_contact(contacts = {})
    contacts = contacts[:contacts]

    response = RestClient.post api_path + "contacts", { "contacts[]" => contacts }, headers
    puts response
  end
  
  def api_path
    if @eo_sandbox == "development"
      "http://localhost:3000/api/"
    elsif @eo_sandbox == "edge"
      "http://edge.emailopened.com/api/"
    elsif @eo_sandbox == "staging"
      "http://staging.emailopened.com/api/"
    else
      "https://app.emailopened.com/api/"
    end
  end
end
